# @billogram/foundation-list-data-provider

> A React component for fetching list data

## Install

```
yarn add @billogram/foundation-list-data-provider
```

## Usage

```tsx
import {
    FoundationListDataProvider,
} from '@billogram/foundation-list-data-provider';
```

See [types](src/types.ts) for exported types.

### [`FoundationListDataProvider`](src/FoundationListDataProvider.tsx)

```tsx
import {
    Data,
    Options,
} from './types';


function ListDataFetchingComponent() {
    function fetchData(): Promise<FoundationListDataProviderFetchResult<Data>> {
        return Promise.resolve({});
    }

    const initialFetchDataOptions: Options = {};

    return (
        <FoundationListDataProvider
            fetchData={ fetchData }
            initialFetchDataOptions={ initialFetchDataOptions }>
            { ({ fetchMore, fetchSort, result }) => (
                <div>...</div>
            ) }
        </FoundationListDataProvider>
    );
}
```

## Note

This library is being published with our use cases in mind and is not necessarily meant to be consumed by the broader public. We probably won't take your feature requests unless they align with our own needs.

## License

MIT
