import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { useCallback, useEffect, useRef, useState } from 'react';
import { makeCancelablePromise } from '@billogram/cancelable-promise';
import listDataFetched from './listDataFetched';

function noop() {}

export default function FoundationListDataProvider(_ref) {
  var children = _ref.children,
      fetchData = _ref.fetchData,
      initialFetchDataOptions = _ref.initialFetchDataOptions,
      _ref$initialLimit = _ref.initialLimit,
      initialLimit = _ref$initialLimit === void 0 ? 10 : _ref$initialLimit,
      _ref$initialSortBy = _ref.initialSortBy,
      initialSortBy = _ref$initialSortBy === void 0 ? 'created_at' : _ref$initialSortBy,
      _ref$initialSortDirec = _ref.initialSortDirection,
      initialSortDirection = _ref$initialSortDirec === void 0 ? 'desc' : _ref$initialSortDirec;
  var cancel = useRef(noop);

  var _useState = useState({
    state: 'fetching-initial'
  }),
      _useState2 = _slicedToArray(_useState, 2),
      result = _useState2[0],
      setResult = _useState2[1];

  var fetch = useCallback(
  /*#__PURE__*/
  function () {
    var _fetch = _asyncToGenerator(
    /*#__PURE__*/
    _regeneratorRuntime.mark(function _callee(listOptions, options) {
      var limit, _makeCancelablePromis, _makeCancelablePromis2, newRequest, newCancel, token, _token;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              cancel.current();
              setResult(function (result) {
                switch (result.state) {
                  case 'error-initial':
                  case 'fetching-initial':
                    {
                      return {
                        state: 'fetching-initial'
                      };
                    }

                  default:
                    {
                      return {
                        data: result.data,
                        meta: result.meta,
                        state: listOptions.mode
                      };
                    }
                }
              });
              limit = listOptions.limit !== void 0 ? listOptions.limit : initialLimit;
              _makeCancelablePromis = makeCancelablePromise(fetchData(listOptions.offset, limit, listOptions.sortBy, listOptions.sortDirection, options)), _makeCancelablePromis2 = _slicedToArray(_makeCancelablePromis, 2), newRequest = _makeCancelablePromis2[0], newCancel = _makeCancelablePromis2[1];
              cancel.current = newCancel;
              _context.next = 8;
              return newRequest;

            case 8:
              token = _context.sent;

              if (!token.isPromiseCanceled) {
                setResult(listDataFetched(token.value));
              }

              _context.next = 16;
              break;

            case 12:
              _context.prev = 12;
              _context.t0 = _context["catch"](0);
              _token = _context.t0;

              if (!_token.isPromiseCanceled) {
                setResult(function (result) {
                  switch (result.state) {
                    case 'error-initial':
                    case 'fetching-initial':
                      {
                        return {
                          state: 'error-initial'
                        };
                      }

                    default:
                      {
                        return {
                          data: result.data,
                          meta: result.meta,
                          state: listOptions.mode === 'fetching-more' ? 'error-more' : 'error-sort'
                        };
                      }
                  }
                });
              }

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 12]]);
    }));

    function fetch(_x, _x2) {
      return _fetch.apply(this, arguments);
    }

    return fetch;
  }(), [fetchData, initialLimit]);
  var fetchInitial = useCallback(function initial(options) {
    fetch({
      mode: 'fetching-initial',
      offset: 0,
      sortBy: initialSortBy,
      sortDirection: initialSortDirection
    }, options);
  }, [fetch, initialSortBy, initialSortDirection]);
  var fetchMore = useCallback(function more(limit, options) {
    switch (result.state) {
      case 'error-initial':
      case 'fetching-initial':
        {
          break;
        }

      default:
        {
          fetch({
            limit: limit,
            mode: 'fetching-more',
            offset: result.data.items.length,
            sortBy: result.meta.sortBy,
            sortDirection: result.meta.sortDirection
          }, options);
          break;
        }
    }
  }, [fetch, result]);
  var fetchSort = useCallback(function sort(sortBy, options) {
    switch (result.state) {
      case 'error-initial':
      case 'fetching-initial':
        {
          break;
        }

      default:
        {
          var sortDirection = result.meta.sortBy !== sortBy ? result.meta.sortDirection : result.meta.sortDirection === 'asc' ? 'desc' : 'asc';
          fetch({
            mode: 'fetching-sort',
            offset: 0,
            sortBy: sortBy,
            sortDirection: sortDirection
          }, options);
          break;
        }
    }
  }, [fetch, result]);
  useEffect(function () {
    fetchInitial(initialFetchDataOptions);
    return function () {
      cancel.current();
      cancel.current = noop;
    };
  }, [fetch, fetchInitial, initialFetchDataOptions, initialSortBy, initialSortDirection]);
  return children({
    fetchInitial: fetchInitial,
    fetchMore: fetchMore,
    fetchSort: fetchSort,
    result: result
  });
}
//# sourceMappingURL=FoundationListDataProvider.js.map